#!/usr/bin/perl
#use locale;
#------------------------------------------------------------#
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) 
 {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
 }
$temp = $ENV{'QUERY_STRING'};
@pairs = split(/&/,$temp);
foreach $item(@pairs) 
 {
  ($key, $content) = split (/=/, $item, 2);
  $content =~ tr/+/ /;
  $content =~ s/%(..)/pack("c",hex($1))/ge;
  $FORM{$key} = $content;
 }
#------------------------------------------------------------#
sub get_WORD
 { return unpack "v", (substr $_[0],$_[1],4); }

sub get_DWORD
 { return unpack "V", (substr $_[0],$_[1],4); }

sub get_WORD_symbols
 { return pack "v", $_[0]; }

sub get_DWORD_symbols
 { return pack "V", $_[0]; }

sub read_block
 {
  # $_[0] -  
  # $_[1] -         
  # $_[2] -      
  # $_[3] -  
  open FILE,$_[0];
  $stat_info .= ($_[2]."    ".$_[1]."<br>");
  binmode FILE;
  seek FILE,$_[1],0; read FILE,$_[3],$_[2];
  close FILE;
 }

sub get_time
 {
  ($sec, $min, $hour) = (localtime)[0..2];
  if($sec < 10){ $sec = "0$sec"; };
  if($min < 10){ $min = "0$min"; };
  if($hour < 10){ $hour = "0$hour"; };
  return "$hour:$min:$sec";
 }

sub reset_document
 {
  $stat_info =~ s/\x5c/\\x5c/g;
  my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";
  print <<HTML;
  <script type='text/javascript'><!--
  parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
  parent.document.compare_tlk_form.reset();
  parent.FLAG_no_action = 0;
  parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
  // --></script>
HTML

  exit;
 }

#-----------------------------------------------------------------------#
print "content-type: text/html; charset=Windows-1251\n\n";

$stat_info .= "<b>".(($FORM{'exclusionary_search'}) ? "" : "")."  tlk-</b> ...<br>";

#      
my $match_count = 0;
#     (  ) 
my $matched_strings_joined;
#    tlk-
my $FILE1_content;
my $FILE2_content;
#   tlk-
my $FILE1_size;
my $FILE2_size;
#   tlk-
my $FILE1_version;
my $FILE2_version;
#   tlk- 
my $FILE1_type;
my $FILE2_type;
#   tlk-
my $FILE1_header_length;
my $FILE2_header_length;
#     tlk-
# 40 -  TLK V3.0
# 26 -  TLK V1
#    tlk-
my $FILE1_strings;
my $FILE2_strings;
#    tlk-    
my $FILE1_strings_offset;
my $FILE2_strings_offset;
#    tlk-
my $FILE1_string_number;
my $FILE2_string_number;
#        tlk-
my $FILE1_sdt_offset;
my $FILE2_sdt_offset;
#       tlk-
my $FILE1_string_offset;
my $FILE2_string_offset;
#     
my $FILE1_string_length;
my $FILE2_string_length;
#   
my $FILE1_string_text;
my $FILE2_string_text;
#     tlk-
my $FILE1_strings_data_table;
my $FILE2_strings_data_table;
#   tlk-
my $FILE1_strings_content;
my $FILE2_strings_content;

#    
if($FORM{'search_in_matched'})
 { @search_in = split ",",$FORM{'matched_strings_joined'}; };
#     
if($FORM{'search_from_this'})
 { $start_search_position =  ($FORM{'search_in_matched'}) ? @search_in[0] : $FORM{'string_number'}; }
#     
else{ $start_search_position = ($FORM{'search_in_matched'}) ? @search_in[0] : 0; }

#   tlk-    
if(!-r $FORM{'main_file'})
 { $stat_info .= ":  tlk-       !<br>";
   reset_document(); };
$stat_info .= " tlk-:<br><nobr>".$FORM{'main_file'}."</nobr><br>";
open FILE,$FORM{'main_file'}; binmode FILE;
#     ( )
(undef, undef, undef, undef, undef, undef, undef, $FILE1_size) = stat FILE;
read FILE,$FILE1_content,$FILE1_size;
#  
seek FILE,0,0; read FILE,$FILE1_header,20;
#   
seek FILE,0,0; read FILE,$FILE1_type,4;
#   
seek FILE,4,0; read FILE,$FILE1_version,4;
if($FILE1_type ne "TLK ")
 { $stat_info .= ":  tlk-   TLK !<br>";
   reset_document(); }
elsif($FILE1_version eq "V3.0")
 {
  #  
  $FILE1_header_length = 20;
  #        
  $FILE1_strings_offset = get_DWORD($FILE1_header,16);
  #    
  seek FILE,12,0; read FILE,$FILE1_strings,4; $FILE1_strings = (unpack "V", $FILE1_strings) - 1;
  #        
  seek FILE,16,0; read FILE,$FILE1_strings_offset,4; $FILE1_strings_offset = unpack "V", $FILE1_strings_offset;
 }
elsif($FILE1_version eq "V1  ")
 {
  $FILE1_header_length = 18;
  $FILE1_strings_offset = get_DWORD($FILE1_header,14);
  seek FILE,10,0; read FILE,$FILE1_strings,4; $FILE1_strings = (unpack "V", $FILE1_strings) - 1;
  seek FILE,14,0; read FILE,$FILE1_strings_offset,4; $FILE1_strings_offset = unpack "V", $FILE1_strings_offset;
 }
else
 { $stat_info .= ":   tlk-  !<br>";
   reset_document(); }
close FILE;

$stat_info .= "->       ... ";
read_block($FORM{'main_file'},$FILE1_header_length,$FILE1_strings_offset-$FILE1_header_length,$FILE1_strings_data_table);

#    
if($FORM{'exactly_search'})
 { $stat_info .= "->     ... ";
   read_block($FORM{'main_file'},$FILE1_strings_offset,$FILE1_size-$FILE1_strings_offset,$FILE1_strings_content); };

#   tlk-    
if(!-r $FORM{'add_file'})
 { $stat_info .= ":  tlk-       !<br>";
   reset_document(); };
$stat_info .= (" tlk-:<br><nobr>".$FORM{'add_file'}."</nobr><br>");
open FILE,$FORM{'add_file'}; binmode FILE;
#     ( )
(undef, undef, undef, undef, undef, undef, undef, $FILE2_size) = stat FILE;
read FILE,$FILE2_content,$FILE2_size;
#  
seek FILE,0,0; read FILE,$FILE2_header,20;
#   
seek FILE,0,0; read FILE,$FILE2_type,4;
#   
seek FILE,4,0; read FILE,$FILE2_version,4;
if($FILE2_type ne "TLK ")
 { $stat_info .= ":  tlk-   TLK !<br>";
   reset_document(); }
elsif($FILE2_version eq "V3.0")
 {
  #  
  $FILE2_header_length = 20;
  #        
  $FILE2_strings_offset = get_DWORD($FILE2_header,16);
  #    
  seek FILE,12,0; read FILE,$FILE2_strings,4; $FILE2_strings = (unpack "V", $FILE2_strings) - 1;
  #        
  seek FILE,16,0; read FILE,$FILE2_strings_offset,4; $FILE2_strings_offset = unpack "V", $FILE2_strings_offset;
 }
elsif($FILE2_version eq "V1  ")
 {
  $FILE2_header_length = 18;
  $FILE2_strings_offset = get_DWORD($header,14);
  seek FILE,10,0; read FILE,$FILE2_strings,4; $FILE2_strings = (unpack "V", $FILE2_strings) - 1;
  seek FILE,14,0; read FILE,$FILE2_strings_offset,4; $FILE2_strings_offset = unpack "V", $FILE2_strings_offset;
 }
else
 { $stat_info .= ":   tlk-  !<br>";
   reset_document(); }
close FILE2;

$stat_info .= "->       ... ";
read_block($FORM{'add_file'},$FILE2_header_length,$FILE2_strings_offset-$FILE2_header_length,$FILE2_strings_data_table);

#    
if($FORM{'exactly_search'})
 { $stat_info .= "->     ... ";
   read_block($FORM{'add_file'},$FILE2_strings_offset,$FILE2_size-$FILE2_strings_offset,$FILE2_strings_content); };

#  -  
my $end_search_position = ($FILE1_strings > $FILE2_strings) ? $FILE2_strings : $FILE1_strings;

#$FILE1_strings_content =~ s/\r/_/g;
#$FILE1_strings_content =~ s/\n/_/g;
#$FILE1_strings_content =~ s/\\/_/g;
#$FILE1_strings_content =~ s/\//_/g;
#$FILE1_strings_content =~ s/\$/_/g;
#$FILE1_strings_content =~ s/\^/_/g;
#$FILE1_strings_content =~ s/\*/_/g;
#$FILE1_strings_content =~ s/\(/_/g;
#$FILE1_strings_content =~ s/\)/_/g;
#$FILE1_strings_content =~ s/\+/_/g;
#$FILE1_strings_content =~ s/\"/_/g;
#$FILE1_strings_content =~ s/\?/_/g;
#$FILE1_strings_content =~ s/\|/_/g;
#$FILE1_strings_content =~ s/\[/_/g;
#$FILE1_strings_content =~ s/\./_/g;
#$FILE1_strings_content =~ s/\ /_/g;

#$FILE2_strings_content =~ s/\r/_/g;
#$FILE2_strings_content =~ s/\n/_/g;
#$FILE2_strings_content =~ s/\\/_/g;
#$FILE2_strings_content =~ s/\//_/g;
#$FILE2_strings_content =~ s/\$/_/g;
#$FILE2_strings_content =~ s/\^/_/g;
#$FILE2_strings_content =~ s/\*/_/g;
#$FILE2_strings_content =~ s/\(/_/g;
#$FILE2_strings_content =~ s/\)/_/g;
#$FILE2_strings_content =~ s/\+/_/g;
#$FILE2_strings_content =~ s/\"/_/g;
#$FILE2_strings_content =~ s/\?/_/g;
#$FILE2_strings_content =~ s/\|/_/g;
#$FILE2_strings_content =~ s/\[/_/g;
#$FILE2_strings_content =~ s/\./_/g;
#$FILE2_strings_content =~ s/\ /_/g;

$stat_info .= (($FORM{'exclusionary_search'}) ? " " : " ").(($FORM{'exactly_search'}) ? "  " : "  ").(($FORM{'search_in_matched'}) ? "  " : "  " )." ...<br>";

#      
if($FORM{'no_check_register'} && $FILE1_strings_content && $FILE2_strings_content)
 { $stat_info .= "->        ...<br>";
   $FILE1_strings_content =~ tr/-/-/; $FILE1_strings_content =~ tr/A-Z/a-z/;
   $FILE2_strings_content =~ tr/-/-/; $FILE2_strings_content =~ tr/A-Z/a-z/; };

 #     
 my $FILE1_current_offset;
 my $FILE1_current_length;
 my $FILE2_current_offset;
 my $FILE2_current_length;
 my $FILE1_current_string;
 my $FILE2_current_string;

if(!$FORM{'search_in_matched'} && !$FORM{'exactly_search'} && !$FORM{'exclusionary_search'})
 #   1:      
 {
  for my $n ($start_search_position..$end_search_position)
   {
    if($match_count eq $FORM{'search_count'}){ next; };
    #       
    if($FILE1_version eq "V3.0")
     { $FILE1_current_length = get_DWORD($FILE1_strings_data_table,40*$n+32); }
    elsif($FILE1_version eq "V1  ")
     { $FILE1_current_length = get_DWORD($FILE1_strings_data_table,26*$n+22); }
    #       
    if($FILE2_version eq "V3.0")
     { $FILE2_current_length = get_DWORD($FILE2_strings_data_table,40*$n+32); }
    elsif($FILE2_version eq "V1  ")
     { $FILE2_current_length = get_DWORD($FILE2_strings_data_table,26*$n+22); }
    #   
    if($FILE1_current_length ne $FILE2_current_length)
     { $matched_strings_joined .= $n.","; $match_count++; };
   }
 #   1:      
 }
elsif(!$FORM{'search_in_matched'} && !$FORM{'exactly_search'} && $FORM{'exclusionary_search'})
 #   2:      
 {
  for my $n ($start_search_position..$end_search_position)
   {
    if($match_count eq $FORM{'search_count'}){ next; };
    if($FILE1_version eq "V3.0")
     { $FILE1_current_length = get_DWORD($FILE1_strings_data_table,40*$n+32); }
    elsif($FILE1_version eq "V1  ")
     { $FILE1_current_length = get_DWORD($FILE1_strings_data_table,26*$n+22); }
    if($FILE2_version eq "V3.0")
     { $FILE2_current_length = get_DWORD($FILE2_strings_data_table,40*$n+32); }
    elsif($FILE2_version eq "V1  ")
     { $FILE2_current_length = get_DWORD($FILE2_strings_data_table,26*$n+22); }
    if($FILE1_current_length eq $FILE2_current_length)
     { $matched_strings_joined .= $n.","; $match_count++; };
   }
 #   2:      
 }
elsif(!$FORM{'search_in_matched'} && $FORM{'exactly_search'} && !$FORM{'exclusionary_search'})
 #   3:      
 {
  for my $n ($start_search_position..$end_search_position)
   {
    if($match_count eq $FORM{'search_count'}){ next; };
    #       
    if($FILE1_version eq "V3.0")
     { $FILE1_current_offset = get_DWORD($FILE1_strings_data_table,40*$n+28);
       $FILE1_current_length = get_DWORD($FILE1_strings_data_table,40*$n+32);
       #my $FILE1_current_Flags = substr $FILE1_strings_data_table,40*$n,4;
       #my $FILE1_current_SoundResRef = substr $FILE1_strings_data_table,40*$n+4,16;
     }
    elsif($FILE1_version eq "V1  ")
     { $FILE1_current_offset = get_DWORD($FILE1_strings_data_table,26*$n+18);
       $FILE1_current_length = get_DWORD($FILE1_strings_data_table,26*$n+22);
       #my $FILE1_current_Flags = substr $FILE1_strings_data_table,26*$n,2;
       #my $FILE1_current_SoundResRef = substr $FILE1_strings_data_table,26*$n+2,8;
     }
    #       
    if($FILE2_version eq "V3.0")
     { $FILE2_current_offset = get_DWORD($FILE2_strings_data_table,40*$n+28);
       $FILE2_current_length = get_DWORD($FILE2_strings_data_table,40*$n+32);
       #my $FILE2_current_Flags = substr $FILE2_strings_data_table,40*$n,4;
       #my $FILE2_current_SoundResRef = substr $FILE2_strings_data_table,40*$n+4,16;
     }
    elsif($FILE2_version eq "V1  ")
     { $FILE2_current_offset = get_DWORD($FILE2_strings_data_table,26*$n+18);
       $FILE2_current_length = get_DWORD($FILE2_strings_data_table,26*$n+22);
       #my $FILE2_current_Flags = substr $FILE2_strings_data_table,26*$n,2;
       #my $FILE2_current_SoundResRef = substr $FILE2_strings_data_table,26*$n+2,8;
     }
    #     
    $FILE1_current_string = substr $FILE1_strings_content,$FILE1_current_offset,$FILE1_current_length;
    $FILE2_current_string = substr $FILE2_strings_content,$FILE2_current_offset,$FILE2_current_length;
    #   
    if($FILE1_current_string ne $FILE2_current_string)
     { $matched_strings_joined .= $n.","; $match_count++; };
   }
 #   3:      
 }
elsif(!$FORM{'search_in_matched'} && $FORM{'exactly_search'} && $FORM{'exclusionary_search'})
 #   4:      
 {
  for my $n ($start_search_position..$end_search_position)
   {
    if($match_count eq $FORM{'search_count'}){ next; };
    if($FILE1_version eq "V3.0")
     { $FILE1_current_offset = get_DWORD($FILE1_strings_data_table,40*$n+28);
       $FILE1_current_length = get_DWORD($FILE1_strings_data_table,40*$n+32);
       #my $FILE1_current_SoundResRef = substr $FILE1_strings_data_table,40*$n+4,16;
     }
    elsif($FILE1_version eq "V1  ")
     { $FILE1_current_offset = get_DWORD($FILE1_strings_data_table,26*$n+18);
       $FILE1_current_length = get_DWORD($FILE1_strings_data_table,26*$n+22);
       #my $FILE1_current_SoundResRef = substr $FILE1_strings_data_table,26*$n+2,8;
     }
    if($FILE2_version eq "V3.0")
     { $FILE2_current_offset = get_DWORD($FILE2_strings_data_table,40*$n+28);
       $FILE2_current_length = get_DWORD($FILE2_strings_data_table,40*$n+32);
       #my $FILE2_current_SoundResRef = substr $FILE2_strings_data_table,40*$n+4,16;
     }
    elsif($FILE2_version eq "V1  ")
     { $FILE2_current_offset = get_DWORD($FILE2_strings_data_table,26*$n+18);
       $FILE2_current_length = get_DWORD($FILE2_strings_data_table,26*$n+22);
       #my $FILE2_current_SoundResRef = substr $FILE2_strings_data_table,26*$n+2,8;
     }
    $FILE1_current_string = substr $FILE1_strings_content,$FILE1_current_offset,$FILE1_current_length;
    $FILE2_current_string = substr $FILE2_strings_content,$FILE2_current_offset,$FILE2_current_length;
    #   
    if($FILE1_current_string eq $FILE2_current_string)
     { $matched_strings_joined .= $n.","; $match_count++; };
   }
 #   4:      
 }
elsif($FORM{'search_in_matched'} && !$FORM{'exactly_search'} && !$FORM{'exclusionary_search'})
 #   5:      
 {
  foreach my $n(@search_in)
   {
    if($match_count eq $FORM{'search_count'}){ next; };
    if($FILE1_version eq "V3.0")
     { $FILE1_current_length = get_DWORD($FILE1_strings_data_table,40*$n+32); }
    elsif($FILE1_version eq "V1  ")
     { $FILE1_current_length = get_DWORD($FILE1_strings_data_table,26*$n+22); }
    if($FILE2_version eq "V3.0")
     { $FILE2_current_length = get_DWORD($FILE2_strings_data_table,40*$n+32); }
    elsif($FILE2_version eq "V1  ")
     { $FILE2_current_length = get_DWORD($FILE2_strings_data_table,26*$n+22); }
    if($FILE1_current_length ne $FILE2_current_length)
     { $matched_strings_joined .= $n.","; $match_count++; };
   }
 #   5:      
 }
elsif($FORM{'search_in_matched'} && !$FORM{'exactly_search'} && $FORM{'exclusionary_search'})
 #   6:      
 {
  foreach my $n(@search_in)
   {
    if($match_count eq $FORM{'search_count'}){ next; };
    if($FILE1_version eq "V3.0")
     { $FILE1_current_length = get_DWORD($FILE1_strings_data_table,40*$n+32); }
    elsif($FILE1_version eq "V1  ")
     { $FILE1_current_length = get_DWORD($FILE1_strings_data_table,26*$n+22); }
    if($FILE2_version eq "V3.0")
     { $FILE2_current_length = get_DWORD($FILE2_strings_data_table,26*$n+32); }
    elsif($FILE2_version eq "V1  ")
     { $FILE2_current_length = get_DWORD($FILE2_strings_data_table,26*$n+22); }
    if($FILE1_current_length eq $FILE2_current_length)
     { $matched_strings_joined .= $n.","; $match_count++; };
   }
 #   6:      
 }
elsif($FORM{'search_in_matched'} && $FORM{'exactly_search'} && !$FORM{'exclusionary_search'})
 #   7:      
 {
  foreach my $n(@search_in)
   {
    if($match_count eq $FORM{'search_count'}){ next; };
    if($FILE1_version eq "V3.0")
     { $FILE1_current_offset = get_DWORD($FILE1_strings_data_table,40*$n+28);
       $FILE1_current_length = get_DWORD($FILE1_strings_data_table,40*$n+32);
       #my $FILE1_current_SoundResRef = substr $FILE1_strings_data_table,40*$n+4,16;
     }
    elsif($FILE1_version eq "V1  ")
     { $FILE1_current_offset = get_DWORD($FILE1_strings_data_table,26*$n+18);
       $FILE1_current_length = get_DWORD($FILE1_strings_data_table,26*$n+22);
       #my $FILE1_current_SoundResRef = substr $FILE1_strings_data_table,26*$n+2,8;
     }
    if($FILE2_version eq "V3.0")
     { $FILE2_current_offset = get_DWORD($FILE2_strings_data_table,40*$n+28);
       $FILE2_current_length = get_DWORD($FILE2_strings_data_table,40*$n+32);
       #my $FILE2_current_SoundResRef = substr $FILE2_strings_data_table,40*$n+4,16;
     }
    elsif($FILE2_version eq "V1  ")
     { $FILE2_current_offset = get_DWORD($FILE2_strings_data_table,26*$n+18);
       $FILE2_current_length = get_DWORD($FILE2_strings_data_table,26*$n+22);
       #my $FILE2_current_SoundResRef = substr $FILE2_strings_data_table,26*$n+2,8;
     }
    $FILE1_current_string = substr $FILE1_strings_content,$FILE1_current_offset,$FILE1_current_length;
    $FILE2_current_string = substr $FILE2_strings_content,$FILE2_current_offset,$FILE2_current_length;
    if($FILE1_current_string ne $FILE2_current_string)
     { $matched_strings_joined .= $n.","; $match_count++; };
   }
 #   7:      
 }
elsif($FORM{'search_in_matched'} && $FORM{'exactly_search'} && $FORM{'exclusionary_search'})
 #   8:      
 {
  foreach my $n(@search_in)
   {
    if($match_count eq $FORM{'search_count'}){ next; };
    if($FILE1_version eq "V3.0")
     { $FILE1_current_offset = get_DWORD($FILE1_strings_data_table,40*$n+28);
       $FILE1_current_length = get_DWORD($FILE1_strings_data_table,40*$n+32);
       #my $FILE1_current_SoundResRef = substr $FILE1_strings_data_table,40*$n+4,16;
     }
    elsif($FILE1_version eq "V1  ")
     { $FILE1_current_offset = get_DWORD($FILE1_strings_data_table,26*$n+18);
       $FILE1_current_length = get_DWORD($FILE1_strings_data_table,26*$n+22);
       #my $FILE1_current_SoundResRef = substr $FILE1_strings_data_table,26*$n+2,8;
     }
    if($FILE2_version eq "V3.0")
     { $FILE2_current_offset = get_DWORD($FILE2_strings_data_table,40*$n+28);
       $FILE2_current_length = get_DWORD($FILE2_strings_data_table,40*$n+32);
       #my $FILE2_current_SoundResRef = substr $FILE2_strings_data_table,40*$n+4,16;
     }
    elsif($FILE2_version eq "V1  ")
     { $FILE2_current_offset = get_DWORD($FILE2_strings_data_table,26*$n+18);
       $FILE2_current_length = get_DWORD($FILE2_strings_data_table,26*$n+22);
       #my $FILE2_current_SoundResRef = substr $FILE2_strings_data_table,26*$n+2,8;
     }
    $FILE1_current_string = substr $FILE1_strings_content,$FILE1_current_offset,$FILE1_current_length;
    $FILE2_current_string = substr $FILE2_strings_content,$FILE2_current_offset,$FILE2_current_length;
    if($FILE1_current_string eq $FILE2_current_string)
     { $matched_strings_joined .= $n.","; $match_count++; };
   }
 #   8:      
 }

#        
$matched_strings_joined =~ s/\,$//;

if($matched_strings_joined =~ /^([0-9]{1,6})\,/){ $first_matched_string = $1; }
if($matched_strings_joined =~ /\,([0-9]{1,6})$/){ $last_matched_string = $1; }

if($match_count != 0)
 { $stat_info .= ("->  ".(($FORM{'exclusionary_search'}) ? "" : "")." : ".$match_count." ...   ".$first_matched_string."   ".$last_matched_string."<br>"); }
else
 { $stat_info .= ":          ...<br>"; reset_document(); }

$stat_info .= "->    ".$first_matched_string." ...<br>";

#      
$FILE1_string_number = $first_matched_string;

#      
if($FILE1_version eq "V3.0")
 {
  #           
  $FILE1_sdt_offset = substr $FILE1_strings_data_table,$FILE1_string_number*40,40;
  #          
  $FILE1_string_offset = $FILE1_strings_offset + (unpack "V", substr $FILE1_sdt_offset,28,4);
  #        
  $FILE1_string_length = unpack "V", substr $FILE1_sdt_offset,32,4;

  #  
  $string_flag = get_DWORD($FILE1_sdt_offset,0);
  #     
  $sound_link = (substr $FILE1_sdt_offset,4,16);
  $sound_link =~ s/\W//g;
  if($sound_link eq ""){ $sound_link = ""; };
  #      
  $sound_volume = get_DWORD($FILE1_sdt_offset,20);
  #  /    
  $sound_pitch = get_DWORD($FILE1_sdt_offset,24);
  #    32-   
  $sound_length = unpack "f", (substr $FILE1_sdt_offset,36,4);
 }
elsif($FILE1_version eq "V1  ")
 {
  $FILE1_sdt_offset = substr $FILE1_strings_data_table,$FILE1_string_number*26,26;
  #          
  $FILE1_string_offset = $FILE1_strings_offset + (unpack "V", substr $FILE1_sdt_offset,18,4);
  #        
  $FILE1_string_length = unpack "V", substr $FILE1_sdt_offset,22,4;

  $string_flag = get_WORD($FILE1_sdt_offset,0);
  $sound_link = (substr $FILE1_sdt_offset,2,8);
  $sound_link =~ s/\W//g;
  if($sound_link eq ""){ $sound_link = ""; };
  $sound_volume = get_DWORD($FILE1_sdt_offset,10);
  $sound_pitch = get_DWORD($FILE1_sdt_offset,14);
  $sound_length = " ";
 }
#      
$FILE1_string_text = substr $FILE1_content,$FILE1_string_offset,$FILE1_string_length;

#      
$FILE2_string_number = $FILE1_string_number;

if($FILE2_version eq "V3.0")
 {
  $FILE2_sdt_offset = substr $FILE2_strings_data_table,$FILE2_string_number*40,40;
  $FILE2_string_offset = $FILE2_strings_offset + (unpack "V", substr $FILE2_sdt_offset,28,4);
  $FILE2_string_length = unpack "V", substr $FILE2_sdt_offset,32,4;
 }
elsif($FILE2_version eq "V1  ")
 {
  $FILE2_sdt_offset = substr $FILE2_strings_data_table,$FILE2_string_number*26,26;
  $FILE2_string_offset = $FILE2_strings_offset + (unpack "V", substr $FILE2_sdt_offset,18,4);
  $FILE2_string_length = unpack "V", substr $FILE2_sdt_offset,22,4;
 }
$FILE2_string_text = substr $FILE2_content,$FILE2_string_offset,$FILE2_string_length;

#   (5c),   (0a  0d)   (22)  
$FILE1_string_text =~ s/\x5c/\\x5c/g;
$FILE1_string_text =~ s/\x0a/\\x0a/g;
if($FILE1_string_text =~ s/\x0d/\\x0d/g)
 { $stat_info .= "->   tlk-    ...<br>"; }; 
$FILE1_string_text =~ s/\x22/\\x22/g;

#   (5c),   (0a  0d)   (22)  
$FILE2_string_text =~ s/\x5c/\\x5c/g;
$FILE2_string_text =~ s/\x0a/\\x0a/g;
if($FILE2_string_text =~ s/\x0d/\\x0d/g)
 { $stat_info .= "->   tlk-    ...<br>"; };
$FILE2_string_text =~ s/\x22/\\x22/g;

$stat_info =~ s/\x5c/\\x5c/g;

my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";

#      
print <<HTML;
<script type='text/javascript'><!--

if("$FORM{'add_file'}")
 { parent.document.main_form.string_content2.value = "$FILE2_string_text";
   parent.document.main_form.string_content2.title = " .   $start_search_position;   /.   ."; };

parent.document.getElementById("search_nav").style.display = "";
parent.document.main_form.search_in_matched.disabled = false;
parent.document.getElementById("matched_strings_tooltip").title = "   tlk-";
parent.matched_strings = "$matched_strings_joined".split(",");

parent.current_search_position = 0;
parent.document.main_form.input_matched_string.value = 1;
parent.document.main_form.input_matched_strings.value = parent.matched_strings.length;

if(parent.document.main_form.string_number.value != parent.matched_strings[0])
 { parent.last_string_number = parent.document.main_form.string_number.value;
   parent.document.main_form.string_number.value = parent.matched_strings[0];
   parent.current_string_number = parent.document.main_form.string_number.value; };

parent.document.main_form.string_content.value = "$FILE1_string_text";

parent.document.getElementById("string_info").style.display = "";
parent.document.getElementById("string_no_info").style.display = "none";
parent.document.main_form.to_undo_button.style.display = "";
parent.document.main_form.from_undo_button.style.display = "none";

parent.document.getElementById("string_flag").innerHTML = "$string_flag";
parent.document.getElementById("string_length").innerHTML = "$FILE1_string_length";
parent.document.getElementById("string_offset").innerHTML = "$FILE1_string_offset";
parent.document.getElementById("sound_link").innerHTML = "$sound_link";
parent.document.getElementById("sound_volume").innerHTML = "$sound_volume";
parent.document.getElementById("sound_pitch").innerHTML = "$sound_pitch";
parent.document.getElementById("sound_length").innerHTML = "$sound_length";

parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
parent.document.compare_tlk_form.reset();
parent.FLAG_no_action = 0;
parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
// --></script>
HTML
