#!/usr/bin/perl
#use FCGI;
#-------------------------------------------------------------------------------------#
#       $input_string  $ENV{'CONTENT_LENGTH'}
read (STDIN, $input_string, $ENV{'CONTENT_LENGTH'});

#      
@input_pairS = split "&", $input_string;
#       
foreach $input_pair (@input_pairS)
 {
  #   -  
  ($name, $value) = split "=", $input_pair;
  $FORM{$name} = $value;
  #   -  
  ($key, $content) = split "=", $input_pair, 2;
  #     
  $content =~ s/\+/ /g;
  #  
  $content =~ s/%([a-fA-F--0-9][a-fA-F--0-9])/pack "C", hex($1)/eg;
  #    
  $content =~ s/\r//g;
  $FORM{$key} = $content;
 }
#-------------------------------------------------------------------------------------#
sub get_WORD
 { return unpack "v", (substr $_[0],$_[1],4); }

sub get_DWORD
 { return unpack "V", (substr $_[0],$_[1],4); }

sub get_WORD_symbols
 { return pack "v", $_[0]; }

sub get_DWORD_symbols
 { return pack "V", $_[0]; }

sub read_block
 {
  open FILE,$FORM{'file_path'};
  $stat_info .= ($_[1]."    ".$_[0]."<br>");
  binmode FILE;
  seek FILE,$_[0],0; read FILE,$_[2],$_[1];
  close FILE;
 }

sub reset_document
 {
  $stat_info =~ s/\x5c/\\x5c/g;
  my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  : <span id='span_stat_info'></span> .</blockquote>";
  print <<HTML;
  <script type='text/javascript'><!--
parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
parent.document.SoundResRef_form.reset();
parent.document.getElementById("iframe_SoundResRef_list").style.display = "";
parent.document.main_form.SoundResRef_button.value = "<";
parent.document.main_form.SoundResRef_button.title = "       tlk-.";
parent.FLAG_SoundResRef_list_cleared = 0;
parent.FLAG_no_action = 0;
parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
on);
  // --></script>
HTML

  exit;
 }

sub get_date
 {
  ($day, $mn, $yr) = (localtime)[3..5];
  if($day < 10){ $day = "0$day"; };
  $mn = ($mn < 10) ? "0($mn+1)" : ($mn+1);
  if($yr < 2000){ $yr += 1900; };
  return "$day$mn$yr";
 }

sub get_time
 {
  ($sec, $min, $hour) = (localtime)[0..2];
  if($sec < 10){ $sec = "0$sec"; };
  if($min < 10){ $min = "0$min"; };
  if($hour < 10){ $hour = "0$hour"; };
  return "$hour:$min:$sec";
 }
#-----------------------------------------------------------------------#
print "content-type: text/html; charset=Windows-1251\n\n<style type='text/css'><!-- body { margin: 0px; padding: 2px; border-width: 0px; } .SoundResRef_item_out { margin: 0px; background-color: #ffffff; color: #000000; font: normal 10px verdana; } .SoundResRef_item_over { margin: 0px; cursor: pointer; cursor: hand; background-color: #cccccc; color: green; font: normal 10px verdana; } table { width: 100%; font: normal 10px verdana; margin: 0px; padding: 0px; cursor: default; text-align: left; vertical-align: middle; } td{ border: 1px solid #cccccc; padding: 1px 4px 1px 4px; } .header_off{ cursor: pointer; cursor: hand; font-weight: bold; background-color: #ffffff; color: #000000; } .header_on{ cursor: default; font-weight: bold; background-color: #999999; color: #ffffff; } --></style>";

$stat_info .= ("     ...<br>");

#  
if(!-r $FORM{'file_path'}){ $stat_info .= (":  ".$FORM{'file_path'}."       !<br>"); reset_document(); };
open FILE,$FORM{'file_path'};
#     ( )
(undef, undef, undef, undef, undef, undef, undef, $file_size) = stat FILE;
#  
close FILE;
$stat_info .= ("->     ... ");
read_block(0,20,$header);
#   
$file_type = substr $header,0,4;
if($file_type ne "TLK ")
 { $stat_info .= (":   ".$FORM{'file_path'}."  !<br>"); reset_document(); };
#  
$file_version = substr $header,4,4;
if($file_version eq "V3.0")
 {
  #     
  $file_strings = (get_DWORD($header,12) - 1);
  #        
  $strings_offset = get_DWORD($header,16);
 }
elsif($file_version eq "V1  ")
 {
  $file_strings = (get_DWORD($header,10) - 1);
  $strings_offset = get_DWORD($header,14);
 }

if($file_version eq "V3.0")
 { $header_length = 20; $string_data_length = 40; }
elsif($file_version eq "V1  ")
 { $header_length = 18; $string_data_length = 26; }

$stat_info .= "->       ... ";
read_block($header_length,$strings_offset-$header_length,$strings_data_table);

$stat_info .= "->   ... ";
my $output_content = "";

my $links_count;
my @links_array;
my $table_header;
if($file_version eq "V3.0" && $FORM{"sorting"} eq "0_9")
 {
  for my $n (0..$file_strings)
   {
    my $current_sound_link = substr $strings_data_table,$string_data_length*$n+4,16; $current_sound_link =~ s/\W//g;
    if(ord $current_sound_link){ $links_count++; $output_content .= "<tr class='SoundResRef_item_out' onMouseOver=this.className='SoundResRef_item_over' onMouseOut=this.className='SoundResRef_item_out' onClick=get_string($n) onContextMenu='parent.string_change(); return false'><td title=' .  -   -   .'>$n</td><td title='  .  -   -   .'>$current_sound_link</td></tr>"; };
   }
   $table_header = "<thead><tr><td class='header_on'></td><td class='header_off' onClick=\"parent.get_SoundResRef_list('a_z');\" title='     .'></td></tr></thead>";
  }
elsif($file_version eq "V3.0" && $FORM{"sorting"} eq "a_z")
 {
  for my $n (0..$file_strings)
   {
    my $current_sound_link = substr $strings_data_table,$string_data_length*$n+4,16; $current_sound_link =~ s/\W//g;
    if(ord $current_sound_link){ $links_count++; $links_array{$current_sound_link} = $n; };
   }
  foreach my $m (sort keys(%links_array)){ $output_content .= "<tr class='SoundResRef_item_out' onMouseOver=this.className='SoundResRef_item_over' onMouseOut=this.className='SoundResRef_item_out' onClick=get_string($links_array{$m}) onContextMenu='parent.string_change(); return false'><td title=' .  -   -   .'>$links_array{$m}</td><td title='  .  -   -   .'>$m</td></tr>"; }
   $table_header = "<thead><tr><td class='header_off' onClick=\"parent.get_SoundResRef_list('0_9');\" title='    .'></td><td class='header_on'></td></tr></thead>";
  }
elsif($file_version eq "V1  " && $FORM{"sorting"} eq "0_9")
 {
  for my $n (0..$file_strings)
   {
    my $current_sound_link = substr $strings_data_table,$string_data_length*$n+2,8; $current_sound_link =~ s/\W//g;
    if(ord $current_sound_link){ $links_count++; $output_content .= "<tr class='SoundResRef_item_out' onMouseOver=this.className='SoundResRef_item_over' onMouseOut=this.className='SoundResRef_item_out' onClick=get_string($n) onContextMenu='parent.string_change(); return false'><td title=' .  -   -   .'>$n</td><td title='  .  -   -   .'>$current_sound_link</td></tr>"; };
   }
   $table_header = "<thead><tr><td class='header_on'></td><td class='header_off' onClick=\"parent.get_SoundResRef_list('a_z');\" title='     .'></td></tr></thead>";
  }
elsif($file_version eq "V1  " && $FORM{"sorting"} eq "a_z")
 {
  for my $n (0..$file_strings)
   {
    my $current_sound_link = substr $strings_data_table,$string_data_length*$n+2,8; $current_sound_link =~ s/\W//g;
    if(ord $current_sound_link){ $links_count++; $links_array{$current_sound_link} = $n; };
   }
  foreach my $m (sort keys(%links_array)){ $output_content .= "<tr class='SoundResRef_item_out' onMouseOver=this.className='SoundResRef_item_over' onMouseOut=this.className='SoundResRef_item_out' onClick=get_string($links_array{$m}) onContextMenu='parent.string_change(); return false'><td title=' .  -   -   .'>$links_array{$m}</td><td title='  .  -   -   .'>$m</td></tr>"; }
   $table_header = "<thead><tr><td class='header_off' onClick=\"parent.get_SoundResRef_list('0_9');\" title='    .'></td><td class='header_on'></td></tr></thead>";
  }
else
 {
  $stat_info .= "<br>:    .";
  reset_document();
 }

$stat_info .= ($links_count." <br>");

$stat_info =~ s/\x5c/\\x5c/g;
my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";

print "<table cellspacing=1px>".$table_header."<tbody>".$output_content."</tbody></table>";

#      
print <<HTML;
<script type='text/javascript'><!--

function get_string(_number)
 {
  parent.request_start_time = parent.get_request_time(); 
  parent.document.main_form.string_number.value = _number;
  if(parent.check_submit()){ parent.open_string(); }else{ parent.show_second_string(); }
 }
 
parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
parent.document.SoundResRef_form.reset();
parent.document.getElementById("iframe_SoundResRef_list").style.display = "";
parent.document.main_form.SoundResRef_button.value = "<";
parent.document.main_form.SoundResRef_button.title = "       tlk-.";
parent.FLAG_SoundResRef_list_cleared = 0;
parent.FLAG_no_action = 0;
parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
// --></script>
HTML
