#!/usr/bin/perl
#---------------------------------------------------------------------------------------------------#
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) 
 {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
 }
$temp = $ENV{'QUERY_STRING'};
@pairs = split(/&/,$temp);
foreach $item(@pairs) 
 {
  ($key, $content) = split (/=/, $item, 2);
  $content =~ tr/+/ /;
  $content =~ s/%(..)/pack("c",hex($1))/ge;
  $FORM{$key} = $content;
 }

#---------------------------------------------------------------------------------------------------#
sub get_time
 {
  ($sec, $min, $hour) = (localtime)[0..2];
  if($sec < 10){ $sec = "0$sec"; };
  if($min < 10){ $min = "0$min"; };
  if($hour < 10){ $hour = "0$hour"; };
  return "$hour:$min:$sec";
 }
#---------------------------------------------------------------------------------------------------#
print "content-type: text/html; charset=Windows-1251\n\n";
#---------------------------------------------------------------------------------------------------#
my $stat_info = "<b> </b> ...<br>";
#---------------------------------------------------------------------------------------------------#

#       js-
# x5C - \
# x22 - "
$FORM{'OPTION_quick_string'} =~ s/\x5c/\\x5c/g;
$FORM{'OPTION_quick_string'} =~ s/\x22/\\x22/g;

#     
my $config_path = "../../../www/nfu/tlkedit/common/config/config.js";

#     
my $new_config_content = "//       \ndocument.editor_config_form.OPTION_reset_state.value = ".$FORM{'OPTION_reset_state'}.";\ndocument.editor_config_form.OPTION_profile_as.value = ".$FORM{'OPTION_profile_as'}.";\ndocument.editor_config_form.OPTION_profile_al.value = ".$FORM{'OPTION_profile_al'}.";\ndocument.editor_config_form.OPTION_make_backup.value = ".$FORM{'OPTION_make_backup'}.";\ndocument.editor_config_form.OPTION_clear_undo_on_save.value = ".$FORM{'OPTION_clear_undo_on_save'}.";\ndocument.editor_config_form.OPTION_full_stat.value = ".$FORM{'OPTION_full_stat'}.";\ndocument.editor_config_form.OPTION_string_flag_corr.value = ".$FORM{'OPTION_string_flag_corr'}.";\ndocument.editor_config_form.OPTION_string_return_corr.value = ".$FORM{'OPTION_string_return_corr'}.";\ndocument.editor_config_form.OPTION_debug_mode.value = ".$FORM{'OPTION_debug_mode'}.";\ndocument.editor_config_form.OPTION_sinc_file_nav.value = ".$FORM{'OPTION_sinc_file_nav'}.";\ndocument.editor_config_form.OPTION_replace_text_mode.value = ".$FORM{'OPTION_replace_text_mode'}.";\ndocument.editor_config_form.OPTION_quick_string.value = \"".$FORM{'OPTION_quick_string'}."\";\n//    \ncheck_config();";

#   
if($FORM{'OPTION_make_backup'} eq 1 && -r $config_path)
 {
  my $backup_number = 0;
  while(-r ($config_path.".backup".$backup_number))
   { $backup_number++ };
  rename $config_path, ($config_path.".backup".$backup_number);
  #         
  $stat_info .= "->     :<br><nobr>".$config_path.".backup".$backup_number."</nobr><br>";
 };

#    
open FILE,">".$config_path;
binmode FILE; print FILE $new_config_content; close FILE;
$stat_info .= "->   :<br><nobr>".$config_path."</nobr><br>->  : ".(length $new_config_content)." ";

#   
$stat_info =~ s/\x5c/\\x5c/g;
$output_stat = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."</blockquote>";

#      
#---------------------------------------------------------------------------------------------------#
print <<HTML;
<script type='text/javascript'><!--
parent.document.getElementById("stat_info").innerHTML += "$output_stat";
parent.FLAG_no_action = 0;
// --></script>
HTML
