#!/usr/bin/perl
#use FCGI;
#-------------------------------------------------------------------------------------#
#       $input_string  $ENV{'CONTENT_LENGTH'}
read (STDIN, $input_string, $ENV{'CONTENT_LENGTH'});

#      
@input_pairS = split "&", $input_string;
#       
foreach $input_pair (@input_pairS)
 {
  #   -  
  ($name, $value) = split "=", $input_pair;
  $FORM{$name} = $value;
  #   -  
  ($key, $content) = split "=", $input_pair, 2;
  #     
  $content =~ s/\+/ /g;
  #  
  $content =~ s/%([a-fA-F--0-9][a-fA-F--0-9])/pack "C", hex($1)/eg;
  #    
  $content =~ s/\r//g;
  $FORM{$key} = $content;
 }
#-------------------------------------------------------------------------------------#
sub get_WORD
 { return unpack "v", (substr $_[0],$_[1],4); }

sub get_DWORD
 { return unpack "V", (substr $_[0],$_[1],4); }

sub get_WORD_symbols
 { return pack "v", $_[0]; }

sub get_DWORD_symbols
 { return pack "V", $_[0]; }

sub read_block
 {
  open FILE,$FORM{'file_path'};
  $stat_info .= ($_[1]."    ".$_[0]."<br>");
  binmode FILE;
  seek FILE,$_[0],0; read FILE,$_[2],$_[1];
  close FILE;
 }

sub reset_document
 {
  $stat_info =~ s/\x5c/\\x5c/g;
  my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  : <span id='span_stat_info'></span> .</blockquote>";
  print <<HTML;
  <script type='text/javascript'><!--
  parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
  parent.document.search_in_dlg_form.reset();
  parent.FLAG_no_action = 0;
  parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
  // --></script>
HTML

  exit;
 }

sub get_time
 {
  ($sec, $min, $hour) = (localtime)[0..2];
  if($sec < 10){ $sec = "0$sec"; };
  if($min < 10){ $min = "0$min"; };
  if($hour < 10){ $hour = "0$hour"; };
  return "$hour:$min:$sec";
 }

#   
my $search_path = $FORM{'folder'};
#   
my $search_number = $FORM{'string_number'};
#   
my $output_content = "<span style='font: normal 11px verdana;'> : $search_number<br><nobr> : $search_path</nobr></span><br><table cellspacing='1px' cellpadding='1px' onContextMenu='return false;' style='width: 100%; font: normal 10px verdana; margin: 8px 0px 0px 0px; padding: 0px; cursor: default; text-align: left; vertical-align: middle;'><tr style='cursor: default; font-weight: bold; background-color: #999999; color: #ffffff;'><td width='30px'></td><td width='70px'></td><td width='70px'></td><td></td></tr>";
#  
my $matched_files = 0;
#  
my $first_matched_file;

#-----------------------------------------------------------------------#
print "content-type: text/html; charset=Windows-1251\n\n<style type='text/css'><!-- body { margin: 0px; padding: 2px 2px 2px 8px; border-width: 0px; } .dlg_file_item_out { margin: 0px; background-color: #ffffff; color: #000000; font: normal 10px verdana; } .dlg_file_item_over { margin: 0px; cursor: pointer; cursor: hand; background-color: #cccccc; color: green; font: normal 10px verdana; } .dlg_file_item_click { margin: 0px; cursor: pointer; cursor: hand; background-color: #cccccc; color: red; font: normal 10px verdana; } td { border: 1px solid #cccccc; padding: 1px 4px 1px 4px; } --></style>";

$stat_info .= ("    $search_number ... ".(($FORM{'subfolders'} eq 1) ? "c  <br>" : "  <br>")."->  : $search_path<br>");

#    
opendir DIR,$search_path; @search_path_elements = readdir(DIR); closedir DIR;
#      (-1)
if($#search_path_elements eq -1)
 { $stat_info .= ":    !<br>"; reset_document(); }
else{ $stat_info .= "->    ... ".($#search_path_elements-1)."<br>"; }

#      
for($i = 2; $i <= $#search_path_elements; $i++)
 {
  #     
 	if($FORM{'subfolders'} eq 1 && -d($search_path.$search_path_elements[$i]))
   {
    $stat_info .= ("-> : ".$search_path.$search_path_elements[$i]."\\<br>->    ... ");
    #    
    opendir DIR, $search_path.$search_path_elements[$i]; @subdir_elements = readdir(DIR); closedir DIR;
    $stat_info .= ($#subdir_elements-1)."<br>";
    #     
    for($s = 2; $s <= $#subdir_elements; $s++)
     {
      #      ( )
      if(!-d($search_path.$search_path_elements[$i]."\\".$subdir_elements[$s]))
       { search_in($search_path.$search_path_elements[$i]."\\".$subdir_elements[$s]) }
     }
   }
  #      ( )
  else{ search_in($search_path.@search_path_elements[$i]); }
 }

#       
sub search_in
 {
  # ,    ,   dlg
  if($_[0] !~ /\.dlg/i){ return; };
  #     
  open FILE,$_[0]; binmode FILE; 
  #     ( )
  (undef, undef, undef, undef, undef, undef, undef, $patch_file_size) = stat FILE;
  #    
  seek FILE,0,0;
  #      
  read FILE,$patch_file_content,$patch_file_size;
  #  
  close FILE;

  my $matched_States = 0;
  my $matched_Transitions = 0;
  
  if((substr $patch_file_content,0,4) =~ /DLG / && (substr $patch_file_content,4,4) =~ /V1\.0/)
   {
    #  
    my $numbers_of_States = get_DWORD(substr $patch_file_content,8,4);
    # ,   
    if($numbers_of_States == 0){ return; };
    #   
    my $offset_of_State_Tables = get_DWORD(substr $patch_file_content,12,4);
    #  
    my $numbers_of_Transitions = get_DWORD(substr $patch_file_content,16,4);
    #  
    my $offset_of_Transition_Tables = get_DWORD(substr $patch_file_content,20,4);
    #    
    for($n = 0; $n < $numbers_of_States; $n++)
     {
      if($search_number eq get_DWORD(substr $patch_file_content,$offset_of_State_Tables+$n*16,4))
       { $matched_States++; };
     }
    #    
    for($m = 0; $m < $numbers_of_Transitions; $m++)
     {
      if($search_number eq get_DWORD(substr $patch_file_content,$offset_of_Transition_Tables+8+$m*32,4))
       { $matched_Transitions++; };
     }
    my $matched_all = $matched_States + $matched_Transitions;
    if($matched_all != 0)
     {
      if($first_matched_file eq ""){ $first_matched_file = $_[0]; $first_matched_file =~ s/\x5c/\\x5c/g; };
      $matched_files++;
      my $matched_file = substr $_[0],(length $search_path);
      my $matched_file_for_func = $_[0];
         $matched_file_for_func =~ s/\x5c/\CODE5c/g;   #  
         $matched_file_for_func =~ s/ /CODE00/g;       # 
         $matched_file_for_func =~ s/\x27/CODE27/g;    #  
      $output_content .= "<tr class='dlg_file_item_out' onMouseOver=list_mouse_over(this) onMouseOut=list_mouse_out(this) onClick=parent.load_dlg_file(this,'$matched_file_for_func')><td width='30px' title=' .'>$matched_all</td><td width='70px' title='   ( ).'>$matched_States&nbsp;($numbers_of_States)</td><td width='70px' title='   ( ).'>$matched_Transitions&nbsp;($numbers_of_Transitions)</td><td title='  .'><nobr>$matched_file</nobr></td></tr>"; };
   };
  #else
  # { $stat_info .= ":   dlg-!<br>"; reset_document(); }
 }

$stat_info .= "-> ()    ()  ... $matched_files ()<br>";

$stat_info =~ s/\x5c/\\x5c/g;
my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";

print "$output_content</table>";

#      
print <<HTML;
<script type='text/javascript'><!--

function list_mouse_out(_item)
 { if(_item.className != 'dlg_file_item_click'){_item.className = 'dlg_file_item_out'} }
function list_mouse_over(_item)
 { if(_item.className != 'dlg_file_item_click'){_item.className = 'dlg_file_item_over'} }

parent.document.getElementById("tr_search_in_dlg").style.display = "";
parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
parent.document.search_in_dlg_form.reset();
parent.FLAG_no_action = 0;
parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
if("$FORM{'autoload'}" == 1){ parent.load_dlg_file("","$first_matched_file"); };
// --></script>
HTML
